package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionaryDividendWayDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryDividendWayDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;

import com.friday.custody.dao.DataDictionaryDividendWayDao;
import com.friday.custody.entity.DataDictionaryDividendWayEntity;
import com.friday.custody.service.basicService.DataDictionaryDividendWayService;
import org.springframework.util.CollectionUtils;


@Service("dataDictionaryDividendWayService")
public class DataDictionaryDividendWayServiceImpl extends ServiceImpl<DataDictionaryDividendWayDao, DataDictionaryDividendWayEntity>
        implements DataDictionaryDividendWayService, DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryDividendWayEntity> page = this.page(
                new Query<DataDictionaryDividendWayEntity>().getPage(params),
                new QueryWrapper<DataDictionaryDividendWayEntity>()
        );

        return new PageUtils(page);
    }

    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Autowired
    private DataDictionaryDividendWayDetailsService detailsService;

    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryDividendWayEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryDividendWayDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryDividendWayDetailsEntity::getOriginValue, DataDictionaryDividendWayDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryDividendWayEntity::getId, DataDictionaryDividendWayEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryDividendWayDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionaryDividendWayEntity 查询失败！");
        }
        return result;
    }

    @Override
    public R queryData(String type) {
        List<DataDictionaryDividendWayEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryDividendWayEntity::getKeyStr
                                                                            ,DataDictionaryDividendWayEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }
}